import java.io.*; 

abstract class AbstractOpSpec
{ String prefix = "";

  public void setPrefix(String pre) 
  { prefix = pre; } 

  public void display()
  { display(new PrintWriter(System.out)); }  

  public void displayImp()
  { displayImp(new PrintWriter(System.out)); }  

  public void displayJava()
  { displayJava(new PrintWriter(System.out)); }  

  abstract public void display(PrintWriter out); 

  abstract public void displayImp(PrintWriter out); 

  abstract public void displayJava(PrintWriter out); 

  public void displayJavaImp()
  { displayJava(); } 

  public void displayJavaImp(PrintWriter out)
  { displayJava(out); }

  public void simplify() { }  // default implementation 
}

