import java.util.Vector; 

public class NamedBlock
{ String name;
  Statement body;
  boolean isPre = true;

  public NamedBlock(String n, Statement c)
  { name = n; body = c; }

  public void setBody(Statement s)
  { body = s; }

  public void setPre(boolean p)
  { isPre = p; }

  public boolean isPre()
  { return isPre; } 

  public String toString()
  { String res = "";
    if (isPre) 
    { res = "pre "; }
    else
    { res = "post "; }
    res = res + name + " {\n";
    res = res + body + " }\n";
    return res;
  }

  public Constraint toConstraint(Vector entities, Vector types)
  { // becomes rule that just invokes operation op, which has activity body
    BasicExpression betrue = new BasicExpression("true");
    betrue.setUmlKind(Expression.VALUE); 
    betrue.setType(new Type("boolean",null));
    String opname = name + "Op";
    BehaviouralFeature op = new BehaviouralFeature(opname);
    op.setActivity(body);
    BasicExpression invoke = 
        new BasicExpression("self." + opname + "()",0); 
    Expression callf = invoke.checkIfSetExpression(); 
    Constraint cons = new Constraint(betrue,callf); 
    return cons; 
  } 

}

