class UMLObject extends Named
{ Entity classifier = null;
  boolean terminates = false; 

  UMLObject(String nme)
  { super(nme);  }

  UMLObject(String nme, Entity e)
  { this(nme);
    classifier = e;
  }

  public void setTerminates(boolean b)
  { terminates = b; } 

  public boolean getTerminates()
  { return terminates; } 

  public Object clone()
  { UMLObject res = new UMLObject(getName(),classifier); 
    res.setTerminates(terminates); 
    return res; 
  } 

  public String toString()
  { return label + ": " + classifier; } 

  public Entity getClassifier()
  { return classifier; } 

  public void setClassifier(Entity e)
  { classifier = e; } 
}
