package uml2Ca;

import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Vector;

public interface SystemTypes
{
  public static final int value = 0;
  public static final int attribute = 1;
  public static final int role = 2;
  public static final int variable = 3;
  public static final int constant = 4;
  public static final int function = 5;
  public static final int queryop = 6;
  public static final int operation = 7;
  public static final int classid = 8;

  public class Set
  { private Vector elements = new Vector();

  public static List select_0(List _l)
  { // Implements: members->select(cmember_0_xx | name = "super")
    List _results_0 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { CMember cmember_0_xx = (CMember) _l.get(_i);
      if (cmember_0_xx.getname().equals("super"))
      { _results_0.add(cmember_0_xx); }
    }
    return _results_0;
  }

  public static List select_2(List _l)
  { // Implements: allMembers->select(cmember_2_xx | isKey)
    List _results_2 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { CMember cmember_2_xx = (CMember) _l.get(_i);
      if (cmember_2_xx.getisKey())
      { _results_2.add(cmember_2_xx); }
    }
    return _results_2;
  }



  public static boolean exists_1(List _l)
  { // Implements: allMembers->exists(k|k.isKey)
    for (int _i = 0; _i < _l.size(); _i++)
    { CMember k = (CMember) _l.get(_i);
      if (k.getisKey()) { return true; }
    }
    return false;
  }

  public static boolean exists_3(List _l,CStruct cstructx)
  { // Implements: BinaryExpression->exists(be|be.operator = "->select" & be.left.elementType.name = name)
    for (int _i = 0; _i < _l.size(); _i++)
    { BinaryExpression be = (BinaryExpression) _l.get(_i);
      if (be.getoperator().equals("->select") && be.getleft().getelementType().getname().equals(cstructx.getname())) { return true; }
    }
    return false;
  }

  public static boolean exists_4(List _l,CStruct cstructx)
  { // Implements: BinaryExpression->exists(be|be.operator = "->reject" & be.left.elementType.name = name)
    for (int _i = 0; _i < _l.size(); _i++)
    { BinaryExpression be = (BinaryExpression) _l.get(_i);
      if (be.getoperator().equals("->reject") && be.getleft().getelementType().getname().equals(cstructx.getname())) { return true; }
    }
    return false;
  }

  public static boolean exists_5(List _l,CStruct cstructx)
  { // Implements: BinaryExpression->exists(be|be.operator = "->collect" & be.left.elementType.name = name)
    for (int _i = 0; _i < _l.size(); _i++)
    { BinaryExpression be = (BinaryExpression) _l.get(_i);
      if (be.getoperator().equals("->collect") && be.getleft().getelementType().getname().equals(cstructx.getname())) { return true; }
    }
    return false;
  }

  public static boolean exists_6(List _l,CStruct cstructx)
  { // Implements: BinaryExpression->exists(be|be.operator = "->exists" & be.left.elementType.name = name)
    for (int _i = 0; _i < _l.size(); _i++)
    { BinaryExpression be = (BinaryExpression) _l.get(_i);
      if (be.getoperator().equals("->exists") && be.getleft().getelementType().getname().equals(cstructx.getname())) { return true; }
    }
    return false;
  }

  public static boolean exists_7(List _l,CStruct cstructx)
  { // Implements: BinaryExpression->exists(be|be.operator = "->forAll" & be.left.elementType.name = name)
    for (int _i = 0; _i < _l.size(); _i++)
    { BinaryExpression be = (BinaryExpression) _l.get(_i);
      if (be.getoperator().equals("->forAll") && be.getleft().getelementType().getname().equals(cstructx.getname())) { return true; }
    }
    return false;
  }

  public static boolean exists_8(List _l,CStruct cstructx)
  { // Implements: BinaryExpression->exists(be|be.operator = "->union" & be.left.elementType.name = name)
    for (int _i = 0; _i < _l.size(); _i++)
    { BinaryExpression be = (BinaryExpression) _l.get(_i);
      if (be.getoperator().equals("->union") && be.getleft().getelementType().getname().equals(cstructx.getname())) { return true; }
    }
    return false;
  }

  public static boolean exists_9(List _l,CStruct cstructx)
  { // Implements: BinaryExpression->exists(be|be.operator = "^" & be.left.elementType.name = name)
    for (int _i = 0; _i < _l.size(); _i++)
    { BinaryExpression be = (BinaryExpression) _l.get(_i);
      if (be.getoperator().equals("^") && be.getleft().getelementType().getname().equals(cstructx.getname())) { return true; }
    }
    return false;
  }

  public static boolean exists_10(List _l,CStruct cstructx)
  { // Implements: BinaryExpression->exists(be|be.operator = "->intersection" & be.left.elementType.name = name)
    for (int _i = 0; _i < _l.size(); _i++)
    { BinaryExpression be = (BinaryExpression) _l.get(_i);
      if (be.getoperator().equals("->intersection") && be.getleft().getelementType().getname().equals(cstructx.getname())) { return true; }
    }
    return false;
  }

  public static boolean exists_11(List _l)
  { // Implements: BasicExpression->exists(b|b.data = "insertAt")
    for (int _i = 0; _i < _l.size(); _i++)
    { BasicExpression b = (BasicExpression) _l.get(_i);
      if (b.getdata().equals("insertAt")) { return true; }
    }
    return false;
  }

  public static boolean exists_12(List _l,CStruct cstructx)
  { // Implements: BinaryExpression->exists(be|be.operator = "->exists1" & be.left.elementType.name = name)
    for (int _i = 0; _i < _l.size(); _i++)
    { BinaryExpression be = (BinaryExpression) _l.get(_i);
      if (be.getoperator().equals("->exists1") && be.getleft().getelementType().getname().equals(cstructx.getname())) { return true; }
    }
    return false;
  }

  public static boolean exists_13(List _l,CStruct cstructx)
  { // Implements: BinaryExpression->exists(be|be.operator = "->isUnique" & be.left.elementType.name = name)
    for (int _i = 0; _i < _l.size(); _i++)
    { BinaryExpression be = (BinaryExpression) _l.get(_i);
      if (be.getoperator().equals("->isUnique") && be.getleft().getelementType().getname().equals(cstructx.getname())) { return true; }
    }
    return false;
  }

  public static boolean exists_14(List _l,CStruct cstructx)
  { // Implements: UnaryExpression->exists(be|be.operator = "->asSet" & be.argument.elementType.name = name)
    for (int _i = 0; _i < _l.size(); _i++)
    { UnaryExpression be = (UnaryExpression) _l.get(_i);
      if (be.getoperator().equals("->asSet") && be.getargument().getelementType().getname().equals(cstructx.getname())) { return true; }
    }
    return false;
  }




  public static List collect_15(List _l,String ent,String sup)
  { // implements: anc.members->collect( m | m.inheritedGetterOpDec(ent,sup) )
    List _results_15 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { CMember m = (CMember) _l.get(_i);
      String collect_x = m.inheritedGetterOpDec(ent,sup);
      if (collect_x != null) { _results_15.add(collect_x); }
    }
    return _results_15;
  }

  public static List collect_16(List _l,String ent,CType sup)
  { // implements: sup.members->collect( m | m.inheritedGetterOpDec(ent,sup.name) )
    List _results_16 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { CMember m = (CMember) _l.get(_i);
      String collect_x = m.inheritedGetterOpDec(ent,((CStruct) sup).getname());
      if (collect_x != null) { _results_16.add(collect_x); }
    }
    return _results_16;
  }

  public static List collect_17(List _l,String ent,String sup)
  { // implements: anc.members->collect( m | m.inheritedSetterOpDec(ent,sup) )
    List _results_17 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { CMember m = (CMember) _l.get(_i);
      String collect_x = m.inheritedSetterOpDec(ent,sup);
      if (collect_x != null) { _results_17.add(collect_x); }
    }
    return _results_17;
  }

  public static List collect_18(List _l,String ent,CType sup)
  { // implements: sup.members->collect( m | m.inheritedSetterOpDec(ent,sup.name) )
    List _results_18 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { CMember m = (CMember) _l.get(_i);
      String collect_x = m.inheritedSetterOpDec(ent,((CStruct) sup).getname());
      if (collect_x != null) { _results_18.add(collect_x); }
    }
    return _results_18;
  }

  public static List collect_19(List _l,String ent,String sup)
  { // implements: anc.members->collect( m | m.inheritedAllOpDec(ent,sup) )
    List _results_19 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { CMember m = (CMember) _l.get(_i);
      String collect_x = m.inheritedAllOpDec(ent,sup);
      if (collect_x != null) { _results_19.add(collect_x); }
    }
    return _results_19;
  }

  public static List collect_20(List _l,String ent,CType sup)
  { // implements: sup.members->collect( m | m.inheritedAllOpDec(ent,sup.name) )
    List _results_20 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { CMember m = (CMember) _l.get(_i);
      String collect_x = m.inheritedAllOpDec(ent,((CStruct) sup).getname());
      if (collect_x != null) { _results_20.add(collect_x); }
    }
    return _results_20;
  }


    public static boolean equals(List a, List b)
    { return a.containsAll(b) && b.containsAll(a); }


    public Set add(Object x)
    { if (x != null) { elements.add(x); }
      return this; }

    public Set add(int x)
    { elements.add(new Integer(x));
      return this; }

    public Set add(long x)
    { elements.add(new Long(x));
      return this; }

    public Set add(double x)
    { elements.add(new Double(x));
      return this; }

    public Set add(boolean x)
    { elements.add(new Boolean(x));
      return this; }

    public List getElements() { return elements; }


  public static Comparable max(List l)
  { Comparable res = null; 
    if (l.size() == 0) { return res; }
    res = (Comparable) l.get(0); 
    for (int i = 1; i < l.size(); i++)
    { Comparable e = (Comparable) l.get(i);
      if (res.compareTo(e) < 0) { res = e; } }
    return res; }


  public static Comparable min(List l)
  { Comparable res = null; 
    if (l.size() == 0) { return res; }
    res = (Comparable) l.get(0); 
    for (int i = 1; i < l.size(); i++)
    { Comparable e = (Comparable) l.get(i);
      if (res.compareTo(e) > 0) { res = e; } }
    return res; }


  public static List union(List a, List b)
  { List res = new Vector(); 
    for (int i = 0; i < a.size(); i++)
    { if (a.get(i) == null || res.contains(a.get(i))) { } else { res.add(a.get(i)); } }
    for (int j = 0; j < b.size(); j++)
    { if (b.get(j) == null || res.contains(b.get(j))) { } else { res.add(b.get(j)); } }
    return res; }


  public static List subtract(List a, List b)
  { List res = new Vector(); 
    res.addAll(a);
    res.removeAll(b);
    return res; }

  public static String subtract(String a, String b)
  { String res = ""; 
    for (int i = 0; i < a.length(); i++)
    { if (b.indexOf(a.charAt(i)) < 0) { res = res + a.charAt(i); } }
    return res; }



  public static List intersection(List a, List b)
  { List res = new Vector(); 
    res.addAll(a);
    res.retainAll(b);
    return res; }



  public static List symmetricDifference(List a, List b)
  { List res = new Vector();
    for (int i = 0; i < a.size(); i++)
    { Object _a = a.get(i);
      if (b.contains(_a) || res.contains(_a)) { }
      else { res.add(_a); }
    }
    for (int j = 0; j < b.size(); j++)
    { Object _b = b.get(j);
      if (a.contains(_b) || res.contains(_b)) { }
      else { res.add(_b); }
    }
    return res;
  }



  public static boolean isUnique(List evals)
  { List vals = new Vector(); 
    for (int i = 0; i < evals.size(); i++)
    { Object ob = evals.get(i); 
      if (vals.contains(ob)) { return false; }
      vals.add(ob);
    }
    return true;
  }


  public static int sumint(List a)
  { int sum = 0; 
    for (int i = 0; i < a.size(); i++)
    { Integer x = (Integer) a.get(i); 
      if (x != null) { sum += x.intValue(); }
    } 
    return sum; }

  public static double sumdouble(List a)
  { double sum = 0.0; 
    for (int i = 0; i < a.size(); i++)
    { Double x = (Double) a.get(i); 
      if (x != null) { sum += x.doubleValue(); }
    } 
    return sum; }

  public static long sumlong(List a)
  { long sum = 0; 
    for (int i = 0; i < a.size(); i++)
    { Long x = (Long) a.get(i); 
      if (x != null) { sum += x.longValue(); }
    } 
    return sum; }

  public static String sumString(List a)
  { String sum = ""; 
    for (int i = 0; i < a.size(); i++)
    { Object x = a.get(i); 
      sum = sum + x; }
    return sum;  }



  public static int prdint(List a)
  { int res = 1; 
    for (int i = 0; i < a.size(); i++)
    { Integer x = (Integer) a.get(i); 
      if (x != null) { res *= x.intValue(); }
    } 
    return res; }

  public static double prddouble(List a)
  { double res = 1; 
    for (int i = 0; i < a.size(); i++)
    { Double x = (Double) a.get(i); 
      if (x != null) { res *= x.doubleValue(); }
    } 
    return res; }

  public static long prdlong(List a)
  { long res = 1; 
    for (int i = 0; i < a.size(); i++)
    { Long x = (Long) a.get(i); 
      if (x != null) { res *= x.longValue(); }
    }
    return res;  }



  public static List concatenate(List a, List b)
  { List res = new Vector(); 
    res.addAll(a); 
    res.addAll(b); 
    return res; }


  public static List closureCollectionExpressionelements(List _r)
  { Vector _path = new Vector();
    for (int _i = 0; _i < _r.size(); _i++)
    { CollectionExpression collectionexpressionx = (CollectionExpression) _r.get(_i);
      closureCollectionExpressionelements(collectionexpressionx, _path);
    }
    return _path;
  }

  private static void closureCollectionExpressionelements(CollectionExpression collectionexpressionx, List _path)
  { if (_path.contains(collectionexpressionx)) { return; }
    _path.add(collectionexpressionx);
    List elementsx = collectionexpressionx.getelements();
    for (int _i = 0; _i < elementsx.size(); _i++)
    { if (elementsx.get(_i) instanceof CollectionExpression)
      { CollectionExpression collectionexpressionxx = (CollectionExpression) elementsx.get(_i);
        closureCollectionExpressionelements(collectionexpressionxx, _path);
      }
      else { _path.add(elementsx.get(_i)); }
    }
  }
  public static List closureBasicExpressionparameters(List _r)
  { Vector _path = new Vector();
    for (int _i = 0; _i < _r.size(); _i++)
    { BasicExpression basicexpressionx = (BasicExpression) _r.get(_i);
      closureBasicExpressionparameters(basicexpressionx, _path);
    }
    return _path;
  }

  private static void closureBasicExpressionparameters(BasicExpression basicexpressionx, List _path)
  { if (_path.contains(basicexpressionx)) { return; }
    _path.add(basicexpressionx);
    List parametersx = basicexpressionx.getparameters();
    for (int _i = 0; _i < parametersx.size(); _i++)
    { if (parametersx.get(_i) instanceof BasicExpression)
      { BasicExpression basicexpressionxx = (BasicExpression) parametersx.get(_i);
        closureBasicExpressionparameters(basicexpressionxx, _path);
      }
      else { _path.add(parametersx.get(_i)); }
    }
  }
  public static List closureBasicExpressionarrayIndex(List _r)
  { Vector _path = new Vector();
    for (int _i = 0; _i < _r.size(); _i++)
    { BasicExpression basicexpressionx = (BasicExpression) _r.get(_i);
      closureBasicExpressionarrayIndex(basicexpressionx, _path);
    }
    return _path;
  }

  private static void closureBasicExpressionarrayIndex(BasicExpression basicexpressionx, List _path)
  { if (_path.contains(basicexpressionx)) { return; }
    _path.add(basicexpressionx);
    List arrayIndexx = basicexpressionx.getarrayIndex();
    for (int _i = 0; _i < arrayIndexx.size(); _i++)
    { if (arrayIndexx.get(_i) instanceof BasicExpression)
      { BasicExpression basicexpressionxx = (BasicExpression) arrayIndexx.get(_i);
        closureBasicExpressionarrayIndex(basicexpressionxx, _path);
      }
      else { _path.add(arrayIndexx.get(_i)); }
    }
  }
  public static List closureBasicExpressionobjectRef(List _r)
  { Vector _path = new Vector();
    for (int _i = 0; _i < _r.size(); _i++)
    { BasicExpression basicexpressionx = (BasicExpression) _r.get(_i);
      closureBasicExpressionobjectRef(basicexpressionx, _path);
    }
    return _path;
  }

  private static void closureBasicExpressionobjectRef(BasicExpression basicexpressionx, List _path)
  { if (_path.contains(basicexpressionx)) { return; }
    _path.add(basicexpressionx);
    List objectRefx = basicexpressionx.getobjectRef();
    for (int _i = 0; _i < objectRefx.size(); _i++)
    { if (objectRefx.get(_i) instanceof BasicExpression)
      { BasicExpression basicexpressionxx = (BasicExpression) objectRefx.get(_i);
        closureBasicExpressionobjectRef(basicexpressionxx, _path);
      }
      else { _path.add(objectRefx.get(_i)); }
    }
  }
  public static List closureConditionalStatementelsePart(List _r)
  { Vector _path = new Vector();
    for (int _i = 0; _i < _r.size(); _i++)
    { ConditionalStatement conditionalstatementx = (ConditionalStatement) _r.get(_i);
      closureConditionalStatementelsePart(conditionalstatementx, _path);
    }
    return _path;
  }

  private static void closureConditionalStatementelsePart(ConditionalStatement conditionalstatementx, List _path)
  { if (_path.contains(conditionalstatementx)) { return; }
    _path.add(conditionalstatementx);
    List elsePartx = conditionalstatementx.getelsePart();
    for (int _i = 0; _i < elsePartx.size(); _i++)
    { if (elsePartx.get(_i) instanceof ConditionalStatement)
      { ConditionalStatement conditionalstatementxx = (ConditionalStatement) elsePartx.get(_i);
        closureConditionalStatementelsePart(conditionalstatementxx, _path);
      }
      else { _path.add(elsePartx.get(_i)); }
    }
  }
  public static List closureSequenceStatementstatements(List _r)
  { Vector _path = new Vector();
    for (int _i = 0; _i < _r.size(); _i++)
    { SequenceStatement sequencestatementx = (SequenceStatement) _r.get(_i);
      closureSequenceStatementstatements(sequencestatementx, _path);
    }
    return _path;
  }

  private static void closureSequenceStatementstatements(SequenceStatement sequencestatementx, List _path)
  { if (_path.contains(sequencestatementx)) { return; }
    _path.add(sequencestatementx);
    List statementsx = sequencestatementx.getstatements();
    for (int _i = 0; _i < statementsx.size(); _i++)
    { if (statementsx.get(_i) instanceof SequenceStatement)
      { SequenceStatement sequencestatementxx = (SequenceStatement) statementsx.get(_i);
        closureSequenceStatementstatements(sequencestatementxx, _path);
      }
      else { _path.add(statementsx.get(_i)); }
    }
  }


  public static List asSet(List a)
  { List res = new Vector(); 
    for (int i = 0; i < a.size(); i++)
    { Object obj = a.get(i);
      if (res.contains(obj)) { } 
      else { res.add(obj); }
    } 
    return res; 
  }


  public static List reverse(List a)
  { List res = new Vector(); 
    for (int i = a.size() - 1; i >= 0; i--)
    { res.add(a.get(i)); } 
    return res; }

  public static String reverse(String a)
  { String res = ""; 
    for (int i = a.length() - 1; i >= 0; i--)
    { res = res + a.charAt(i); } 
    return res; }



  public static List front(List a)
  { List res = new Vector(); 
    for (int i = 0; i < a.size() - 1; i++)
    { res.add(a.get(i)); } 
    return res; }


  public static List tail(List a)
  { List res = new Vector(); 
    for (int i = 1; i < a.size(); i++)
    { res.add(a.get(i)); } 
    return res; }


    public static Object first(List v)
    { if (v.size() == 0) { return null; }
      return v.get(0);
    }


    public static Object last(List v)
    { if (v.size() == 0) { return null; }
      return v.get(v.size() - 1);
    }



  public static List sort(final List a)
  { int i = a.size()-1;
    return mergeSort(a,0,i);
  }

  static List mergeSort(final List a, int ind1, int ind2)
  { List res = new Vector();
    if (ind1 > ind2)
    { return res; }
    if (ind1 == ind2)
    { res.add(a.get(ind1));
      return res;
    }
    int mid = (ind1 + ind2)/2;
    List a1;
    List a2;
    if (mid == ind1)
    { a1 = new Vector();
      a1.add(a.get(ind1));
      a2 = mergeSort(a,mid+1,ind2);
    }
    else
    { a1 = mergeSort(a,ind1,mid-1);
      a2 = mergeSort(a,mid,ind2);
    }
    int i = 0;
    int j = 0;
    while (i < a1.size() && j < a2.size())
    { Comparable e1 = (Comparable) a1.get(i); 
      Comparable e2 = (Comparable) a2.get(j);
      if (e1.compareTo(e2) < 0) // e1 < e2
      { res.add(e1);
        i++; // get next e1
      } 
      else 
      { res.add(e2);
        j++; 
      } 
    } 
    if (i == a1.size())
    { for (int k = j; k < a2.size(); k++)
      { res.add(a2.get(k)); } 
    } 
    else 
    { for (int k = i; k < a1.size(); k++) 
      { res.add(a1.get(k)); } 
    } 
    return res;
  }


  public static List sortedBy(final List a, List f)
  { int i = a.size()-1;
    java.util.Map f_map = new java.util.HashMap();
    for (int j = 0; j < a.size(); j++)
    { f_map.put(a.get(j), f.get(j)); }
    return mergeSort(a,f_map,0,i);
  }

  static List mergeSort(final List a, java.util.Map f, int ind1, int ind2)
  { List res = new Vector();
    if (ind1 > ind2)
    { return res; }
    if (ind1 == ind2)
    { res.add(a.get(ind1));
      return res;
    }
    if (ind2 == ind1 + 1)
    { Comparable e1 = (Comparable) f.get(a.get(ind1)); 
      Comparable e2 = (Comparable) f.get(a.get(ind2));
      if (e1.compareTo(e2) < 0) // e1 < e2
      { res.add(a.get(ind1)); res.add(a.get(ind2)); return res; }
      else 
      { res.add(a.get(ind2)); res.add(a.get(ind1)); return res; }
    }
    int mid = (ind1 + ind2)/2;
    List a1;
    List a2;
    if (mid == ind1)
    { a1 = new Vector();
      a1.add(a.get(ind1));
      a2 = mergeSort(a,f,mid+1,ind2);
    }
    else
    { a1 = mergeSort(a,f,ind1,mid-1);
      a2 = mergeSort(a,f,mid,ind2);
    }
    int i = 0;
    int j = 0;
    while (i < a1.size() && j < a2.size())
    { Comparable e1 = (Comparable) f.get(a1.get(i)); 
      Comparable e2 = (Comparable) f.get(a2.get(j));
      if (e1.compareTo(e2) < 0) // e1 < e2
      { res.add(a1.get(i));
        i++; // get next e1
      } 
      else 
      { res.add(a2.get(j));
        j++; 
      } 
    } 
    if (i == a1.size())
    { for (int k = j; k < a2.size(); k++)
      { res.add(a2.get(k)); } 
    } 
    else 
    { for (int k = i; k < a1.size(); k++) 
      { res.add(a1.get(k)); } 
    } 
    return res;
  }


  public static List integerSubrange(int i, int j)
  { List tmp = new Vector(); 
    for (int k = i; k <= j; k++)
    { tmp.add(new Integer(k)); } 
    return tmp;
  }

  public static String subrange(String s, int i, int j)
  { return s.substring(i-1,j); }

  public static List subrange(List l, int i, int j)
  { List tmp = new Vector(); 
    for (int k = i-1; k < j; k++)
    { tmp.add(l.get(k)); } 
    return tmp; 
  }



  public static List prepend(List l, Object ob)
  { List res = new Vector();
    res.add(ob);
    res.addAll(l);
    return res;
  }


  public static List append(List l, Object ob)
  { List res = new Vector();
    res.addAll(l);
    res.add(ob);
    return res;
  }


  public static int count(List l, Object obj)
  { int res = 0; 
    for (int _i = 0; _i < l.size(); _i++)
    { if (obj == l.get(_i)) { res++; } 
      else if (obj != null && obj.equals(l.get(_i))) { res++; } 
    }
    return res; 
  }

  public static int count(String s, String x)
  { int res = 0; 
    if ("".equals(s)) { return res; }
    int ind = s.indexOf(x); 
    if (ind == -1) { return res; }
    String ss = s.substring(ind+1,s.length());
    res++; 
    while (ind >= 0)
    { ind = ss.indexOf(x); 
      if (ind == -1 || ss.equals("")) { return res; }
      res++; 
      ss = ss.substring(ind+1,ss.length());
    } 
    return res;
  }



  public static List characters(String str)
  { char[] _chars = str.toCharArray();
    Vector _res = new Vector();
    for (int i = 0; i < _chars.length; i++)
    { _res.add("" + _chars[i]); }
    return _res;
  }



    public static Object any(List v)
    { if (v.size() == 0) { return null; }
      return v.get(0);
    }


    public static List subcollections(List v)
    { Vector res = new Vector();
      if (v.size() == 0)
      { res.add(new Vector());
        return res;
      }
      if (v.size() == 1)
      { res.add(new Vector());
        res.add(v);
        return res;
      }
      Vector s = new Vector();
      Object x = v.get(0);
      s.addAll(v);
      s.remove(0);
      List scs = subcollections(s);
      res.addAll(scs);
      for (int i = 0; i < scs.size(); i++)
      { Vector sc = (Vector) scs.get(i);
        Vector scc = new Vector();
        scc.add(x);
        scc.addAll(sc);
        res.add(scc);
      }
      return res;
    }


  public static Vector maximalElements(List s, List v)
  { Vector res = new Vector();
    if (s.size() == 0) { return res; }
    Comparable largest = (Comparable) v.get(0);
    res.add(s.get(0));
    
    for (int i = 1; i < s.size(); i++)
    { Comparable next = (Comparable) v.get(i);
      if (largest.compareTo(next) < 0)
      { largest = next;
        res.clear();
        res.add(s.get(i));
      }
      else if (largest.compareTo(next) == 0)
      { res.add(s.get(i)); }
    }
    return res;
  }

  public static Vector minimalElements(List s, List v)
  { Vector res = new Vector();
    if (s.size() == 0) { return res; }
    Comparable smallest = (Comparable) v.get(0);
    res.add(s.get(0));
    
    for (int i = 1; i < s.size(); i++)
    { Comparable next = (Comparable) v.get(i);
      if (next.compareTo(smallest) < 0)
      { smallest = next;
        res.clear();
        res.add(s.get(i));
      }
      else if (smallest.compareTo(next) == 0)
      { res.add(s.get(i)); }
    }
    return res;
  }


  public static List intersectAll(List se)
  { List res = new Vector(); 
    if (se.size() == 0) { return res; }
    res.addAll((List) se.get(0));
    for (int i = 1; i < se.size(); i++)
    { res.retainAll((List) se.get(i)); }
    return res;
  }



  public static List unionAll(List se)
  { List res = new Vector(); 
    for (int i = 0; i < se.size(); i++)
    { List b = (List) se.get(i); 
      for (int j = 0; j < b.size(); j++)
      { if (res.contains(b.get(j))) { } else { res.add(b.get(j)); } }
    }
    return res;
  }



    public static List concatenateAll(List a)
    { List res = new Vector();
      for (int i = 0; i < a.size(); i++)
      { List r = (List) a.get(i);
        res.addAll(r); 
      }
      return res;
    }



  public static List insertAt(List l, int ind, Object ob)
  { List res = new Vector();
    for (int i = 0; i < ind-1 && i < l.size(); i++)
    { res.add(l.get(i)); }
    if (ind <= l.size() + 1) { res.add(ob); }
    for (int i = ind-1; i < l.size(); i++)
    { res.add(l.get(i)); }
    return res;
  }
  public static String insertAt(String l, int ind, Object ob)
  { String res = "";
    for (int i = 0; i < ind-1 && i < l.length(); i++)
    { res = res + l.charAt(i); }
    if (ind <= l.length() + 1) { res = res + ob; }
    for (int i = ind-1; i < l.length(); i++)
    { res = res + l.charAt(i); }
    return res;
  }


 public static boolean isInteger(String str)
  { try { Integer.parseInt(str); return true; }
    catch (Exception _e) { return false; }
  }


 public static boolean isReal(String str)
  { try { double d = Double.parseDouble(str); 
          if (Double.isNaN(d)) { return false; }
          return true; }
    catch (Exception _e) { return false; }
  }

  }
}
